package decorators;

import swinggui.SpriteInterface;

public class LogDecoration extends SpriteDecorator {

	
	private final String NORTH = "Moving to north";
	private final String SOUTH = "Moving to south";
	private final String WEST = "Moving to west";
	private final String EAST = "Moving to east";	
	
    private final String UNKNOWN = "????";
    
    private  String directionInfo = UNKNOWN;
	
	public LogDecoration (SpriteInterface decoratedSprite) {
		this.decoratedSprite = decoratedSprite;
	}
    
	
	@Override
	public void step() {
		
		decoratedSprite.step();
		
		
		
		int degree =  (int) Math.toDegrees(  decoratedSprite.getRadianRotation() ) ; 
		String newDirection = UNKNOWN;	

		
		if (degree > 315 || degree < 45) {
			newDirection = NORTH ;
		} else if (degree >= 45 && degree < 135) {
			newDirection = EAST ;
		} else if (degree >= 135 && degree < 225) {
			newDirection = SOUTH;
		} else {
			newDirection = WEST;
		}
		
		
		if (newDirection != directionInfo) {
			directionInfo = newDirection;
			
			System.out.println (directionInfo);
			
		}
		
		
	}
	
}
