package decorators;

import java.awt.Point;
import java.awt.Polygon;
import java.awt.image.BufferedImage;

import swinggui.SpriteInterface;
import swinggui.WorldInfo;

abstract public class SpriteDecorator implements SpriteInterface {
	
	
	protected SpriteInterface decoratedSprite;
	
	

	@Override
	public double getRadianRotation() {
		return decoratedSprite.getRadianRotation();
		
	}

	@Override
	public Point getLocation() {
		return decoratedSprite.getLocation();
		
	}

	@Override
	public Point getCenter() {
		return decoratedSprite.getCenter();
		
	}

	@Override
	public BufferedImage getImage() {
		return decoratedSprite.getImage();
	}

	@Override
	public void setLocation(int x, int y) {
		decoratedSprite.setLocation(x, y);
		
	}

	@Override
	public void setRotation(int degree) {
		decoratedSprite.setRotation(degree);
		
	}

	@Override
	public void setWorldInfo(WorldInfo info) {
		decoratedSprite.setWorldInfo(info);
		
	}

	@Override
	public void step() {
		decoratedSprite.step();
		
	}

}
