package strategycharacters;

//Implementations of OnCollisionStrategyInterface provide specific reactions
//for a sprite that collides with world bounds
//SmartSprite.checkCollision() delegates its sprite specic collision behaviour to implementations of this
//strategy. 
//Since the onXXXCollistoin methods get no reference to the sprite, strategy implementations that need
//access to the sprite (e.g. to change direction) need to store a reference to the
// sprite. The reference should be passed in the constructor or with a setter methods.

public interface OnCollisionStrategyInterface {
	
	
	public void onTopCollision();

	public void onBottomCollision();
		
	public void onLeftCollision();
	
	public void onRightCollision() ;

	
}
