package strategycharacters;

import java.awt.Point;
import java.awt.Polygon;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;

import swinggui.SpriteInterface;
import swinggui.WorldInfo;

public class SmartSprite implements SpriteInterface {

	Point location = new Point (0,0);	
	int rotation = 0;
	int stepSize = 12;
    BufferedImage img = null;	
    Polygon strokes = null;
    WorldInfo worldInfo;
    
    // straties for motion and collisions
    OnCollisionStrategyInterface collisionStrategy = null;
    StepStrategy stepStrategy = null;
	
	public SmartSprite () {
		
		   File f = new File("img\\" + fileName());

		   try {
		       img = ImageIO.read(f);
		   } catch (IOException e) {
			   
		   }
		   
	}
	
	

	
	public void setWorldInfo (WorldInfo info) {
		worldInfo = info;
	}
	
	public Polygon getStrokes () { return strokes; }	
	public String fileName()     { return "joker.gif";}
	
	public BufferedImage getImage () {
		return img;
	}
	
	public void setLocation (int x, int y) {
		location = new Point (x,y);
	}
	
	public Point getLocation () {return location; }
	
	public Point getCenter() {
		
		int x = location.x + img.getWidth() / 2;
		int y = location.y + img.getHeight() / 2;	
		return new Point ( x, y);
		
		
	}
	
	
	public void setRotation (int degree) { rotation  = degree; }
	
	public double getRadianRotation () {
		 return Math.toRadians(rotation);
	}
	
	public int getRotation () {
		return rotation;
	}
	
	public WorldInfo getWorldInfo () {
		return worldInfo;
	}
    
    
	// the step logic is final because any special sprite should delegate
    // specific step behaviour to StepStrategies
	final public void step () {
		 // Kollision mit Auenkanten?
         checkCollision();

         stepStrategy.step(this);
         
         // move forward:
		 double r = Math.toRadians(Math.abs(rotation)-90);
	     location.x += Math.round(stepSize * Math.cos(r));  
	     location.y += Math.round(stepSize * Math.sin(r));		
	     

	}
	
	

    
	private void checkCollision() {
		 if (worldInfo == null || collisionStrategy == null) return;
		 if (location.x < worldInfo.getLeft() ) collisionStrategy.onLeftCollision();
		 if (location.x > worldInfo.getRight()) collisionStrategy.onRightCollision() ;
		 if (location.y < worldInfo.getTop() ) collisionStrategy.onTopCollision();
		 if (location.y > worldInfo.getBottom()) collisionStrategy.onBottomCollision();

	}
	
	
	// again the same helper method - you will find this in all 3 implementations because
	// the implementations are independent from each other
	protected void rotateToTarget (Point target) {
		
		Point center = this.getCenter();	
		
    	if (target.x > center.x && target.y < center.y) {
     	   double r = Math.atan2( center.x - target.x , target.y - center.y );	
     	   rotation = (int) Math.round( Math.toDegrees(r)) + 180;
     	     	  	
     	}
     	
    	
         if (target.x > center.x && target.y > center.y) {

            double r = Math.atan2( target.y - center.y ,  center.x - target.x   );	
      	   rotation = 270 - (int) Math.round( Math.toDegrees(r)) 	;
         }
         
         if (target.x < center.x && target.y > center.y) {
             double r = Math.atan2(  center.x - target.x , target.y - center.y  );	
       	   rotation = 180 + (int) Math.round( Math.toDegrees(r)) 	;	
         }
         
         if (target.x < center.x && target.y < center.y) {
             double r = Math.atan2( center.y - target.y , center.x - target.x  );	
       	   rotation = 270 + (int) Math.round( Math.toDegrees(r)) 	;	      	
         	
         }		
		
		
		
	}
	
	

}
