package swinggui;

abstract public class AbstractSpriteFactory {

	
	abstract public SpriteInterface createGekko () ;
	abstract public SpriteInterface createTurtle () ;
	abstract public SpriteInterface createCat();
	abstract public SpriteInterface createDog(SpriteInterface huntedSprite);
	
	
	
	// convenient helpers:
	public SpriteInterface createGekko (int x, int y, int degree,  WorldInfo world) {
		SpriteInterface newSprite = createGekko();
		assignInitValues (newSprite , x, y , degree, world);
		return newSprite;		
	}
	
	
   public SpriteInterface createTurtle (int x, int y, int degree,  WorldInfo world)  {
		SpriteInterface newSprite = createTurtle();
		assignInitValues (newSprite , x, y , degree, world);
		return newSprite;		
	}
	
	 public SpriteInterface createCat(int x, int y, int degree,  WorldInfo world) {
		SpriteInterface newSprite = createCat();
		assignInitValues (newSprite , x, y , degree, world);
		return newSprite;		
	};
	
	public SpriteInterface createDog(int x, int y, int degree,  WorldInfo world, SpriteInterface huntedSprite) {
		SpriteInterface newSprite = createDog(huntedSprite);
		assignInitValues (newSprite , x, y , degree, world);
		return newSprite;		
	}
	
	
	void assignInitValues (SpriteInterface sprite  , int x , int y , int degree, WorldInfo world) {
		sprite.setLocation(x, y);
		sprite.setRotation(degree);
		sprite.setWorldInfo(world);
		
	}
	
}
