package swinggui;

import javax.swing.JFrame;
import javax.swing.JLabel;

import strategycharacters.StrategySpritesFactory;
import stupid.StupidSpriteFactory;
import characters.AnimalFactory;

public class App {

	public static void main(String[] args) {
		createAppWindow();

	}
	
	
	
    private static void createAppWindow() {
        //Create and set up the window.
        JFrame frame = new JFrame("Turtle World App");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frame.setSize(600, 600);
 
        //Create the turtle world component
        JTurtleWorld world = new JTurtleWorld();
        
        // use the different sprite families directly:
        //world.initStupidSprites();
        //world.initBetterSprites();
        world.initBestSprites();
        
        // use the different sprite families via abstract factory 
        //world.initSpritesWithFactory(new StupidSpriteFactory());
        //world.initSpritesWithFactory(new AnimalFactory());
        //world.initSpritesWithFactory(new StrategySpritesFactory());

        world.initListeners();
        frame.getContentPane().add(world);
 
        //Display the window.
        frame.setVisible(true);
    }
	
	

}
